#include "stc.h"
#include "uart.h"
#include "iap.h"
#include "dfu.h"

BOOL f1ms;
u16 msCount;
void sys_init();
void Timer0_Init(void);

void main()
{
    dfu_check();
    
    sys_init();
    uart_init();
    iap_init();
    
    while (1)
    {
        uart_isr();
        dfu_events();
				
    }
}

void sys_init()
{
    P_SW2 |= 0x80;
    P3M0 &= ~0x03;
    P3M1 &= ~0x03;
		P2M0 = 0;
		P2M1 = 0;
		P2 = 0xFE;
		
		appConfig.isAppRunning = 0;
		Timer0_Init();
		ET0 = 1; //ж
		EA = 1;
}
void Timer0_Init(void)		//1@24.000MHz
{
	AUXR |= 0x80;			//ʱʱ1Tģʽ
	TMOD &= 0xF0;			//öʱģʽ
	TL0 = 0x40;				//öʱʼֵ
	TH0 = 0xA2;				//öʱʼֵ
	TF0 = 0;				//TF0־
	TR0 = 1;				//ʱ0ʼʱ
}

void Timer0_ISR_Handler (void) interrupt TMR0_VECTOR		//жʱѾ־
{
  
	if(appConfig.isAppRunning && appConfig.app_tm0_isr != NULL){
		((void (code *)())(appConfig.app_tm0_isr))();
	}else{
		f1ms = 1;
	}
	if(f1ms){
		f1ms = 0;
		msCount++;
		if(msCount == 1000){
			msCount = 0;
			P20 = ~P20;
		}
	}
}